﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Timers;

namespace тетрис
{
    class Program
    {
        static char v = 'Ж';
        static char o = '#';
        static char g = 'O';
        static int width = 20; //длина поля
        static int height = 21; //высота поля
        static char[,] field = new char[height, width]; //массив для вывода в консоль
        static int score = 0; //количество пойманных муравьев
        static string itemM;
        static System.Timers.Timer timerAnt;

        static List<Car> cars = new List<Car>();

        static int aeX=width/3+1, aeY=height-8;
        static int aeX2, aeY2, nl=2;
        static void Main(string[] args)
        {
            Console.CursorVisible = false;
            Frame();
            Player();
            WriteField();
            AddCar();
            CreateCar();
            StartTimer();

            while(true)
            {
                MovePlayer();
                if (aeX<0 || aeX>18)
                {
                    GameOver();
                }
                Frame();
                CreateCar();
                WriteField();
                
                
            }


            Console.ReadLine();
        }

        static void GameOver()
        {
            
          
                Console.Clear();
                Console.WriteLine("Результат:" + score);
                Console.WriteLine("Нажмите клавишу Enter для завершения");
                Console.ReadLine();
                Environment.Exit(0);

            
        }
        static void StartTimer()
        {
            timerAnt = new System.Timers.Timer(200);
            timerAnt.Elapsed += OnTimerElapsed;
            timerAnt.AutoReset = true;
            timerAnt.Enabled = true;
        }

        static void OnTimerElapsed(object sender, ElapsedEventArgs e)
        {
            //AddCar();
            //удаление старого положени 
            foreach (var car in cars)
            {
                for (int i = 0; i < height; i++)
                {
                    for (int j = 0; j < width; j++)
                    {
                        if ((i == car.Y || i == car.Y + 1) && (j == car.X + 2 || j == car.X + 3))
                        {
                            field[i, j] = ' ';
                        }
                        if ((i == car.Y + 2 || i == car.Y + 3) && (j >= car.X && j <= car.X + 5))
                        {
                            field[i, j] = ' ';
                        }
                        if ((i == car.Y + 4 || i == car.Y + 5) && (j == car.X + 2 || j == car.X + 3))
                        {
                            field[i, j] = ' ';
                        }
                        if ((i == car.Y + 6 || i == car.Y + 7) && (j == car.X || j == car.X + 1 || j == car.X + 4 || j == car.X + 5))
                        {
                            field[i, j] = ' ';
                        }
                    }
                }
            }


            foreach (var car in cars)
            {
                car.Y += 1;
                if (car.Y > 20)
                {
                    score += 1;
                }
            }

            
               // cars.RemoveAll(car => car.Y >20 || (car.Y>=aeY && nl ==car.Line));

           
            CreateCar();
            
        }

        static void AddCar()
        {
            Random random = new Random();
            int nah = random.Next(1, 3);
            for (int i = 1; i <= 1; i++)
            {
                int line = random.Next(1, 3);
                int x=0;
                int y=-8;
                switch (line)
                {
                    case 1:
                        x = width + 1;
                        
                        break;
                    case 2:
                        x = width + 7;
                        
                        break;
                    case 3:
                        x = width + 13;
                        
                        break;
                }
                
                cars.Add(new Car(x, y, line));
            }
        }

        static void CreateCar()
        {
            foreach (var car in cars)
            {
                for (int i = 0; i < height; i++)
                {
                    for (int j = 0; j < width; j++)
                    {
                        if ((i == car.Y || i == car.Y + 1) && (j == car.X + 2 || j == car.X + 3))
                        {
                            field[i, j] = o;
                        }
                        if ((i == car.Y + 2 || i == car.Y + 3) && (j >= car.X && j <= car.X + 5))
                        {
                            field[i, j] = o;
                        }
                        if ((i == car.Y + 4 || i == car.Y + 5) && (j == car.X + 2 || j == car.X + 3))
                        {
                            field[i, j] = o;
                        }
                        if ((i == car.Y + 6 || i == car.Y + 7) && (j == car.X || j == car.X + 1 || j == car.X + 4 || j == car.X + 5))
                        {
                            field[i, j] = o;
                        }
                    }
                }
            }
        }
        static void Frame()
        {
            //добавление рамки
            for (int i = 0; i < height; i++)
            {
                for (int j = 0; j < width; j++)
                {
                    if (j == 0)
                    {
                        field[i, j] = v;
                    }
                    if (j == width - 1)
                    {
                        field[i, j] = v;
                    }

                }
            }
        }


        static void WriteField()
        {
            //вывод массива
            for (int i = 0; i < height; i++)
            {
                for (int j = 0; j < width; j++)
                {
                    Console.SetCursorPosition(j, i);
                    Console.Write(field[i, j]);

                }
            }
        }
        static void FieldClear()
        {
            for (int i = 0; i < height; i++)
            {
                for (int j = 0; j < width; j++)
                {
                    field[i, j] = ' ';
                }
            }
        }
        static void Player()
        {
            //добавление рамки
            for (int i = 0; i < height; i++)
            {
                for (int j = 0; j < width; j++)
                {
                    if ((i == aeY || i == aeY+1) && (j == aeX+2 ||j ==aeX+3))
                    {
                        field[i, j] = o;
                    }
                    if ((i == aeY+2 || i == aeY+3) && (j >=aeX && j <= aeX+5))
                    {
                        field[i, j] = o;
                    }
                    if ((i == aeY+4 || i == aeY+5) && (j == aeX+2 || j == aeX+3))
                    {
                        field[i, j] = o;
                    }
                    if ((i == aeY+6 || i == aeY+7) && (j ==aeX || j == aeX+1 || j == aeX+4 || j == aeX+5))
                    {
                        field[i, j] = o;
                    }
                }
            }
        }
        static void MovePlayer()
        {
            //перемещение муравьеда
            if (Console.KeyAvailable)
            {

                ConsoleKeyInfo key = Console.ReadKey(true);
                switch (key.Key)
                {
                    
                    case ConsoleKey.LeftArrow:
                        FieldClear();
                        aeX = aeX - 6;
                        Player();
                        nl -= 1;
                        break;
                    case ConsoleKey.RightArrow:
                        FieldClear();
                        aeX = aeX + 6;
                        Player();
                        nl += 1;
                        break;
                }
            }
        }
    }

}
class Car
{
    public int X { get; set; }
    public int Y { get; set; }
    public int Line { get; set; }
    public Car(int x, int y, int line)
    {
        X = x;
        Y = y;
        Line = line;
    }
}
